namespace Deskcandy.Candy {
  public class Video : BaseCandy {
    public bool loop { get; set; default = true; }
    public double speed { get; set; default = 100.0; }

    public Video() {
    }

    public override async void initialize() throws Error {
    }

    public override Subprocess launch(uint socket_id) throws Error {
      message("Launching mpv video...");
      var args = new Array<string>();
      args.append_val("mpv");
      args.append_val(@"--wid=$socket_id");
      args.append_val("--no-audio");
      args.append_val("--no-terminal");
      // TODO: temp
      args.append_val("--video-unscaled=downscale-big");
      args.append_val("--video-zoom=20");
      args.append_val(@"--speed=$(this.speed)");
      if (this.loop) {
        args.append_val("--loop");
      }
      args.append_val(this.name);
      return new Subprocess.newv(args.steal(), SubprocessFlags.NONE);
    }
  }
}
